
/* Chrysalide - Outil d'analyse de fichiers binaires
 * encapsulated-int.h - prototypes internes pour le chargement de données binaires à partir d'un contenu restreint
 *
 * Copyright (C) 2023 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Chrysalide.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _ANALYSIS_CONTENTS_ENCAPSULATED_INT_H
#define _ANALYSIS_CONTENTS_ENCAPSULATED_INT_H


#include "encapsulated.h"


#include "../content-int.h"



/* Contenu de données binaires issues d'un contenu restreint (instance) */
struct _GEncapsContent
{
    GBinContent parent;                     /* A laisser en premier        */

    GBinContent *base;                      /* Base offrant une extraction */
    char *path;                             /* Chemin vers le contenu ciblé*/
    GBinContent *endpoint;                  /* Contenu ciblé               */

    char *full_desc;                        /* Description de l'ensemble   */
    char *desc;                             /* Description de l'ensemble   */

};

/* Contenu de données binaires issues d'un contenu restreint (classe) */
struct _GEncapsContentClass
{
    GBinContentClass parent;                /* A laisser en premier        */

};


/* Met en place un contenu de données brutes encapsulées. */
bool g_encaps_content_create(GEncapsContent *, GBinContent *, const char *, GBinContent *);



#endif  /* _ANALYSIS_CONTENTS_ENCAPSULATED_INT_H */
